# data creation script
# By Magnus Haw
# June 9,2010
from numpy import *

fileName = raw_input("Output filename: ")

total_time = 10
xmax = 10
dx = .2
dt = .2

def f_of_x_t(x,t):
    return e**(-x**2.)*x*sqrt(t)

nx = int((xmax)/dx)
nt = int(total_time/dt)

for l in range(0,4):
    fout = open(fileName+str(l)+".dat", 'w')
    dx= dx/2.
    nx = int((xmax)/dx)

    dt = dt/2.
    nt = int(total_time/dt)

    ###initialize data
    data =[]
    for i in range(0,nt):
        data.append([])
        for j in range(0,nx):
            data[i].append(0)

    fout.write('NumDatasets:1\n\n')

    fout.write('dataset1\n')
    fout.write(str(nt)+'\n')

    fout.write('coords\t')
    for i in range(0,nx):
        fout.write(str(i*dx) + '\t')
    fout.write('\n')

    for i in range(0,nt):
        t=i*dt
        fout.write(str(t)+'\t')
        for j in range(0,nx):
            x=j*dx
            t=i*dt
            data[i][j] = f_of_x_t(x,t)
            fout.write(str(data[i][j])+'\t')
        fout.write('\n')

    fout.close()
