#ifndef APPLY_DEF
#define APPLY_DEF
#include "stdlib.h"
#include "xy_types.h"
#include "types.h"

class app{

public:
    app();

    double               Mindseg_default;
    double               Maxdseg_default;

    /* Applicators. */

    PXYDVBIND            pxydv_yi_fcn(PXYDVBIND,int);
    PXYDVBIND            pxydv_xi_fcn(PXYDVBIND,int);

    //int                  wt_is_time_compressible(WT wt);

    PXYDVBIND            pxydv_blurb(PXYDVBIND);
    PXYDVBIND            pxydv_x_plus_c(PXYDVBIND);
    PXYDVBIND            pxydv_x_times_c(PXYDVBIND);
    PXYDVBIND            pxydv_x_dev_about_mean(PXYDVBIND);
    PXYDVBIND            pxydv_x_to_x_plus_it_dx(PXYDVBIND);
    PXYDVBIND            pxydv_x_to_x_minus_t(PXYDVBIND);
    PXYDVBIND            pxydv_x_to_x_plus_t(PXYDVBIND);
    PXYDVBIND            pxydv_interpolate_x_to_pick_x(PXYDVBIND p);
    PXYDVBIND            pxydv_interpolate_x_to_pick_x_1(PXYDVBIND p);
    PXYDVBIND            pxydv_x_to_pick_x(PXYDVBIND p);
    PXYDVBIND            pxydv_x_to_unit(PXYDVBIND);
    PXYDVBIND            pxydv_x_to_unit_rescale_y(PXYDVBIND p);
    PXYDVBIND            pxydv_x_to_unit_rescale_shift_y(PXYDVBIND p);
    PXYDVBIND            pxydv_x_to_eps_times_sin_omega_x(PXYDVBIND p);
    PXYDVBIND            pxydv_x_to_scaled_x_power_p(PXYDVBIND p);
    PXYDVBIND            pxydv_x_to_scaled_x_power_p_gen(PXYDVBIND p);
    PXYDVBIND            pxydv_x_to_ordinal(PXYDVBIND p);
    PXYDVBIND            pxydv_x_to_dvumsh(PXYDVBIND p);
    PXYDVBIND            pxydv_x_to_dvumsh_local(PXYDVBIND p);
    PXYDVBIND            pxydv_x_to_dvgmsh(PXYDVBIND p);
    PXYDVBIND            pxydv_2_to_1_linear(PXYDVBIND p);
    PXYDVBIND            pxydv_y_plus_c(PXYDVBIND);
    PXYDVBIND            pxydv_y_times_c(PXYDVBIND);
    PXYDVBIND            pxydv_y_dev_about_mean(PXYDVBIND);
    PXYDVBIND            pxydv_y_to_unit(PXYDVBIND p);
    PXYDVBIND            pxydv_each_y_to_unit(PXYDVBIND p);
    PXYDVBIND            pxydv_y_threshold(PXYDVBIND);
    PXYDVBIND            pxydv_y_to_x(PXYDVBIND p);
    PXYDVBIND            pxydv_y_to_y_minus_x(PXYDVBIND p);
    PXYDVBIND            pxydv_y_to_dx(PXYDVBIND p);
    PXYDVBIND            pxydv_y_to_dy(PXYDVBIND p);
    PXYDVBIND            pxydv_y_to_1m21(PXYDVBIND p);
    PXYDVBIND            pxydv_y_to_y_best_linear_fit(PXYDVBIND p);
    PXYDVBIND            pxydv_y_to_dev_from_best_linear_fit(PXYDVBIND p);
    PXYDVBIND            pxydv_y_time_average(PXYDVBIND p);
    PXYDVBIND            pxydv_y_t_y(PXYDVBIND p);
    PXYDVBIND            pxydv_xy_to_dquad(PXYDVBIND p,DQUAD dq);
    PXYDVBIND            pxydv_xyun(PXYDVBIND p);
    PXYDVBIND            pxydv_xyun_symm(PXYDVBIND p);
    PXYDVBIND            pxydv_xytun(PXYDVBIND p);
    PXYDVBIND            pxydv_xytun_and_lintseg_fixed(PXYDVBIND p);
    PXYDVBIND            pxydv_xy_to_dquad_input(PXYDVBIND p);
    PXYDVBIND            pxydv_xy_to_mxmy(PXYDVBIND p);
    PXYDVBIND            old_pxydv_xyun(PXYDVBIND);
    PXYDVBIND            pxydv_t_to_ordinal(PXYDVBIND p);
    PXYDVBIND            pxydv_t_to_unit_interval(PXYDVBIND p);
    PXYDVBIND            pxydv_t_plus_c(PXYDVBIND);
    PXYDVBIND            pxydv_t_times_c(PXYDVBIND);
    PXYDVBIND            pxydv_cpt_to_tau(PXYDVBIND p);
    PXYDVBIND            pxydv_t_ln_t_minus_tstar(PXYDVBIND p);
    PXYDVBIND            pxydv_t_to_y0(PXYDVBIND);
    PXYDVBIND            pxydv_t_to_int_dt(PXYDVBIND);
    PXYDVBIND            pxydv_t_to_pick_t(PXYDVBIND);
    PXYDVBIND            pxydv_t_to_pick_y0(PXYDVBIND);
    PXYDVBIND            pxydv_t_to_pick_int_dt(PXYDVBIND);
    PXYDVBIND            pxydv_t_interpolate_t2_x2(PXYDVBIND);
    PXYDVBIND            pxydv_t_interpolate_t2_x4(PXYDVBIND);
    PXYDVBIND            pxydv_xy_to_yx(PXYDVBIND);
    PXYDVBIND            pxydv_xy_to_vw(PXYDVBIND);
    PXYDVBIND            pxydv_xy_rotate(PXYDVBIND);
    PXYDVBIND            pxydv_flow_field_rescale(PXYDVBIND);
    PXYDVBIND            pxydv_overlay(PXYDVBIND);
    PXYDVBIND            pxydv_xt_transpose(PXYDVBIND p);
    PXYDVBIND            pxydv_cheby_fit_and_generate_f77(PXYDVBIND p);
    PXYDVBIND            pxydv_cheby_fit_and_generate_f77_d(PXYDVBIND p);
    PXYDVBIND            pxydv_cheby_fit_and_generate_ortho_phi(PXYDVBIND p);
    PXYDVBIND            pxydv_cheby_fit_and_generate_f77_x(PXYDVBIND p);
    PXYDVBIND            pxydv_cheby_fit_and_replace(PXYDVBIND p);
    PXYDVBIND            pxydv_cheby_fit_and_append(PXYDVBIND p);

    //PXYDVBIND            pxydv_cheby_fit(PXYDVBIND p,int code,WT s_wt);
    PXYDVBIND            old_pxydv_cheby_fit(PXYDVBIND p,int code);
    void                 write_timeid_file(char *,double);

    PXYDVBIND            pxydv_sort_x(PXYDVBIND p);
    PXYDVBIND            pxydv_sort_pamr(PXYDVBIND p);
    PXYDVBIND            pxydv_y_x_by_1mx(PXYDVBIND p);
    PXYDVBIND            pxydv_x_log(PXYDVBIND);
    PXYDVBIND            pxydv_x_log_c_plus_x(PXYDVBIND p);
    PXYDVBIND            pxydv_x_log_one_plus_x(PXYDVBIND p);
    PXYDVBIND            pxydv_y_log(PXYDVBIND);
    PXYDVBIND            pxydv_dy_dx(PXYDVBIND p);
    PXYDVBIND            pxydv_dy_dx_mid(PXYDVBIND p);
    PXYDVBIND            pxydv_cheby_dy_dx(PXYDVBIND p);
    PXYDVBIND            pxydv_x_dy_dx(PXYDVBIND);
    PXYDVBIND            pxydv_int_dx(PXYDVBIND);
    PXYDVBIND            pxydv_rint_dx(PXYDVBIND);
    PXYDVBIND            pxydv_x_times_y(PXYDVBIND);
    PXYDVBIND            pxydv_y_divide_x(PXYDVBIND);
    PXYDVBIND            pxydv_int_dx_divide_x(PXYDVBIND);
    PXYDVBIND            pxydv_int_x_p_y_dx(PXYDVBIND p);
    PXYDVBIND            pxydv_x_p_times_y(PXYDVBIND);
    PXYDVBIND            pxydv_x_p(PXYDVBIND p);
    PXYDVBIND            pxydv_y_p(PXYDVBIND);
    PXYDVBIND            pxydv_y_make_gaussian_pulse(PXYDVBIND p);
    PXYDVBIND            pxydv_y_make_poly_pulse(PXYDVBIND p);
    PXYDVBIND            pxydv_y_exp_damp_tail(PXYDVBIND);
    PXYDVBIND            pxydv_y_exp_damp_head(PXYDVBIND);
    PXYDVBIND            pxydv_y_poly_roll_off(PXYDVBIND);
    PXYDVBIND            pxydv_y_poly_roll_off_both(PXYDVBIND p);
    PXYDVBIND            pxydv_pulse_isolate_and_reflect(PXYDVBIND p);
    PXYDVBIND            pxydv_phi_r_to_phi_t(PXYDVBIND p);
    PXYDVBIND            pxydv_xy_curvature(PXYDVBIND);
    PXYDVBIND            pxydv_xy_curvature_s(PXYDVBIND);
    PXYDVBIND            pxydv_reflect(PXYDVBIND p);
    PXYDVBIND            pxydv_mofa(PXYDVBIND p);
    PXYDVBIND            pxydv_2mbyrofa(PXYDVBIND p);
    PXYDVBIND            pxydv_dmdrofa(PXYDVBIND p);
    PXYDVBIND            pxydv_aofm(PXYDVBIND);
    PXYDVBIND            pxydv_laplacian_sph_sym(PXYDVBIND p);
    PXYDVBIND            pxydv_r2_laplacian_sph_sym(PXYDVBIND p);
    PXYDVBIND            pxydv_v_plus_r_dvdr(PXYDVBIND p);
    PXYDVBIND            pxydv_lofa(PXYDVBIND);
    PXYDVBIND            pxydv_zeta_of_phi(PXYDVBIND);
    PXYDVBIND            pxydv_w_minus_w0_over_r(PXYDVBIND p);
    PXYDVBIND            pxydv_wsq_minus_w0_sq_over_rsq(PXYDVBIND p);
    PXYDVBIND            pxydv_a_of_u(PXYDVBIND p);
    PXYDVBIND            pxydv_y_sig(PXYDVBIND);
    PXYDVBIND            pxydv_dy_dx_sig(PXYDVBIND);
    PXYDVBIND            pxydv_y_inner_norm(PXYDVBIND);
    PXYDVBIND            pxydv_y_outer_norm(PXYDVBIND);

    PXYDVBIND            pxydv_pbc_impose(PXYDVBIND);
    PXYDVBIND            pxydv_pbc_add(PXYDVBIND);
    PXYDVBIND            pxydv_pbc_delete(PXYDVBIND);
    PXYDVBIND            pxydv_pbc_extend(PXYDVBIND p);

    PXYDVBIND            pxydv_dft_fft(PXYDVBIND p,int direction);
    PXYDVBIND            pxydv_dft_fftf(PXYDVBIND p);
    PXYDVBIND            pxydv_dft_fftr(PXYDVBIND p);
    PXYDVBIND            pxydv_dft_fftp(PXYDVBIND p);

    PXYDVBIND            pxydv_wavelet_daub4 (PXYDVBIND,PFV);
    PXYDVBIND            pxydv_wavelet_daub4f(PXYDVBIND);
    PXYDVBIND            pxydv_wavelet_daub4r(PXYDVBIND);

    PXYDVBIND            pxydv_t_log(PXYDVBIND);

    PXYDVBIND            pxydv_x_negate(PXYDVBIND);
    PXYDVBIND            pxydv_y_negate(PXYDVBIND);

    PXYDVBIND            pxydv_d_dt_y(PXYDVBIND);
    PXYDVBIND            pxydv_pairwise_d_dt_y(PXYDVBIND);
    PXYDVBIND            pxydv_pairwise_average(PXYDVBIND);
    PXYDVBIND            pxydv_d_dt_xy(PXYDVBIND);

    PXYDVBIND            pxydv_filter_every_mth(PXYDVBIND p);
    PXYDVBIND            pxydv_filter_thin(PXYDVBIND p);
    PXYDVBIND            pxydv_filter_lintseg_general(PXYDVBIND p);
    PXYDVBIND            pxydv_filter_lintseg_fixed(PXYDVBIND p);
    PXYDVBIND            pxydv_filter_lintseg_0(PXYDVBIND p,double mindseg,double maxdseg);
    PXYDVBIND            pxydv_filter_c(PXYDVBIND,int,int);
    PXYDVBIND            pxydv_filter_c2_fixed(PXYDVBIND);
    PXYDVBIND            pxydv_filter_c2_general(PXYDVBIND);
    PXYDVBIND            pxydv_filter_c4_fixed(PXYDVBIND);
    PXYDVBIND            pxydv_filter_c4_general(PXYDVBIND);

    PXYDVBIND            pxydv_tag_dummy(PXYDVBIND);
    PXYDVBIND            pxydv_tag_by_dx(PXYDVBIND p);
    PXYDVBIND            pxydv_tag_by_dx_single(PXYDVBIND p);
    PXYDVBIND            pxydv_tag_with_constant(PXYDVBIND);
    PXYDVBIND            pxydv_tag_delete(PXYDVBIND);

    /* Chebyshev fitting codes (now need to be exported for plot.c) ... */

    #define           FIT_AND_GENERATE_F77               0
    #define           FIT_AND_GENERATE_F77_D             1
    #define           FIT_AND_GENERATE_ORTHO_PHI         2
    #define           FIT_AND_GENERATE_F77_X             3
    #define           FIT_AND_REPLACE                    4
    #define           FIT_AND_APPEND                     5
    #define           FIT_AND_GENERATE_F77_WT_NAME     100
};

#endif
